Subject: Re: bug#60356: 30.0.50; individual frame loses keyboard focus, focus cannot be restored

From: Linus Heckemann <[email-masked]>
Date: Tue, 03 Jan 2023 14:11:32 +0100

Eli Zaretskii <[email-masked]> writes:

>> From: [email-masked]
>> Date: Tue, 27 Dec 2022 13:19:44 +0100
>> 
>> 
>> The exact action leading to this bug is not clear to me. It seems to be
>> related to lsp-mode though -- I've not observed it happening without
>> lsp-mode.
>> 
>> The symptom is that a single frame will no longer accept keyboard input,
>> and will visually indicate that it is not focused (outline rectangular
>> cursor where I'd usually expect a solid rectangular cursor). Mouse input
>> still works, and other frames still accept keyboard input as normal.
>> 
>> I'd be glad if anyone could point out ways to further debug this issue.
>> I'm also in #emacs:matrix.org (@linus:schreibt.jetzt) in case
>> fast-turnaround communication would be helpful :)
>
> If you attach a debugger to Emacs in that state, and type
>
>   (gdb) thread apply all bt
>
> what do you get?  Please post here everything that GDB prints when you
> do that.
>
> Thanks.

0x00007f923c305151 in pselect () from /nix/store/4nlgxhb09sdr51nc9hdm8az5b08vzkgx-glibc-2.35-163/lib/libc.so.6
(gdb) thread apply all bt

Thread 3 (Thread 0x7f9223fff640 (LWP 19853) "gdbus"):
#0  0x00007f923c3026c9 in poll () from /nix/store/4nlgxhb09sdr51nc9hdm8az5b08vzkgx-glibc-2.35-163/lib/libc.so.6
#1  0x00007f923ee61c26 in g_main_context_iterate.constprop () from /nix/store/lrvvvkyakljgq3zvpzdwd20cm5hvwy3a-glib-2.74.1/lib/libglib-2.0.so.0
#2  0x00007f923ee61f73 in g_main_loop_run () from /nix/store/lrvvvkyakljgq3zvpzdwd20cm5hvwy3a-glib-2.74.1/lib/libglib-2.0.so.0
#3  0x00007f923f0c7216 in gdbus_shared_thread_func () from /nix/store/lrvvvkyakljgq3zvpzdwd20cm5hvwy3a-glib-2.74.1/lib/libgio-2.0.so.0
#4  0x00007f923ee8c8cd in g_thread_proxy () from /nix/store/lrvvvkyakljgq3zvpzdwd20cm5hvwy3a-glib-2.74.1/lib/libglib-2.0.so.0
#5  0x00007f923c288e86 in start_thread () from /nix/store/4nlgxhb09sdr51nc9hdm8az5b08vzkgx-glibc-2.35-163/lib/libc.so.6
#6  0x00007f923c30fc60 in clone3 () from /nix/store/4nlgxhb09sdr51nc9hdm8az5b08vzkgx-glibc-2.35-163/lib/libc.so.6

Thread 2 (Thread 0x7f922970b640 (LWP 19851) "gmain"):
#0  0x00007f923c3026c9 in poll () from /nix/store/4nlgxhb09sdr51nc9hdm8az5b08vzkgx-glibc-2.35-163/lib/libc.so.6
#1  0x00007f923ee61c26 in g_main_context_iterate.constprop () from /nix/store/lrvvvkyakljgq3zvpzdwd20cm5hvwy3a-glib-2.74.1/lib/libglib-2.0.so.0
#2  0x00007f923ee61d3f in g_main_context_iteration () from /nix/store/lrvvvkyakljgq3zvpzdwd20cm5hvwy3a-glib-2.74.1/lib/libglib-2.0.so.0
#3  0x00007f923ee61d91 in glib_worker_main () from /nix/store/lrvvvkyakljgq3zvpzdwd20cm5hvwy3a-glib-2.74.1/lib/libglib-2.0.so.0
#4  0x00007f923ee8c8cd in g_thread_proxy () from /nix/store/lrvvvkyakljgq3zvpzdwd20cm5hvwy3a-glib-2.74.1/lib/libglib-2.0.so.0
#5  0x00007f923c288e86 in start_thread () from /nix/store/4nlgxhb09sdr51nc9hdm8az5b08vzkgx-glibc-2.35-163/lib/libc.so.6
#6  0x00007f923c30fc60 in clone3 () from /nix/store/4nlgxhb09sdr51nc9hdm8az5b08vzkgx-glibc-2.35-163/lib/libc.so.6

Thread 1 (Thread 0x7f923ad21000 (LWP 19849) "emacs"):
#0  0x00007f923c305151 in pselect () from /nix/store/4nlgxhb09sdr51nc9hdm8az5b08vzkgx-glibc-2.35-163/lib/libc.so.6
#1  0x0000000000626b92 in really_call_select ()
#2  0x000000000062731f in thread_select ()
#3  0x0000000000649a51 in xg_select ()
#4  0x00000000006005d3 in wait_reading_process_output ()
#5  0x0000000000435846 in sit_for ()
#6  0x0000000000524532 in read_char ()
#7  0x0000000000524b30 in read_key_sequence ()
#8  0x00000000005268b1 in command_loop_1 ()
#9  0x000000000059f98f in internal_condition_case ()
#10 0x0000000000511d86 in command_loop_2 ()
#11 0x000000000059f8f3 in internal_catch ()
#12 0x0000000000511d19 in command_loop ()
#13 0x00000000005165ba in recursive_edit_1 ()
#14 0x0000000000516937 in Frecursive_edit ()
#15 0x000000000042abda in main ()
(gdb) c
Continuing.